package lilivel.b4a.miscUtil;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;

import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentResolver;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.ContactsContract;
import android.util.Log;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.objects.collections.Map;

@ShortName("miscUtil") // this is the name as it appear on the IDE
@Permissions(values = {"android.permission.GET_ACCOUNTS", "android.permission.READ_CONTACTS", "android.permission.WRITE_CONTACTS"}) 
@Author("Michael Peter") // your name
@Version(1.04f) // the version
@ActivityObject
public class miscUtil  {

    public static final String TAG = "lilivel.b4a.miscUtil";   
    private BA m_ba;

	/**
	* Common initialisations
	*/	
    public void Initialize(BA ba) {
      m_ba = ba;
    }

	/**
	* Creates an contact entry
	*/
	public void createContactEntry2(String name, Bitmap photo, Map phones, Map emails, String Note, String Website, String Organization, Map homeadress, Map workadress) {

		// Prepare contact creation request
		ArrayList<ContentProviderOperation> ops = new ArrayList<ContentProviderOperation>();
		
		ops.add(ContentProviderOperation.newInsert(ContactsContract.RawContacts.CONTENT_URI)
		.withValue(ContactsContract.RawContacts.ACCOUNT_TYPE, null)   //Account.getType() ?
		.withValue(ContactsContract.RawContacts.ACCOUNT_NAME, null)   //Account.getName() ?
		.build());

		//Name hinzufgen
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.StructuredName.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.StructuredName.DISPLAY_NAME, name)
		.build());
		
		if (photo != null) {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			photo.compress(Bitmap.CompressFormat.JPEG, 100, baos);
			byte[] photodata = baos.toByteArray();
			//Bild hinzufgen
			ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
					.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
					.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Photo.CONTENT_ITEM_TYPE)
					.withValue(ContactsContract.CommonDataKinds.Photo.PHOTO, photodata)
					.build());
		}	
		
		//Telefonnummern hinzufgen
		int iAnz = -1;
		int iKey;
		String sValue = "";
		iAnz = phones.getSize();
		Log.i(TAG,"Creating contact phones: " + iAnz);
		for (int i=0; i<iAnz; i++)  {
			iKey = (Integer) phones.GetKeyAt(i);
			sValue = (String) phones.GetValueAt(i);
			Log.i(TAG,"Creating contact phone: " + sValue);
			ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
			.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
			.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Phone.CONTENT_ITEM_TYPE)
			.withValue(ContactsContract.CommonDataKinds.Phone.NUMBER, sValue)
			.withValue(ContactsContract.CommonDataKinds.Phone.TYPE, iKey)
			.build());
		}
		
		//email hinzufgen
		iAnz = emails.getSize();
		Log.i(TAG,"Creating contact mails: " + iAnz);
		for (int i=0; i<iAnz; i++)  {
			iKey = (Integer) emails.GetKeyAt(i);
			sValue = (String) emails.GetValueAt(i);
			Log.i(TAG,"Creating contact mail: " + emails.GetValueAt(i));
			ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
			.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
			.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Email.CONTENT_ITEM_TYPE)
			.withValue(ContactsContract.CommonDataKinds.Email.DATA, sValue)
			.withValue(ContactsContract.CommonDataKinds.Email.TYPE, iKey)
			.build());
		}

		// Kommentar
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Note.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.Note.DATA1, Note)
		// .withValue(ContactsContract.CommonDataKinds.Note.TYPE, ContactsContract.?
		.build());

		// Firma
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Organization.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.Organization.DATA, Organization)
		// .withValue(ContactsContract.CommonDataKinds.Organization.TYPE, iKey)
		.build());

		// Adresse Home
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.StructuredPostal.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.CITY, (String) homeadress.GetValueAt(0))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.POSTCODE, (String) homeadress.GetValueAt(1))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.STREET, (String) homeadress.GetValueAt(2))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.COUNTRY, (String) homeadress.GetValueAt(3))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.TYPE, ContactsContract.CommonDataKinds.StructuredPostal.TYPE_HOME)
		.build());
		
		
		// Adresse Buero
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.StructuredPostal.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.CITY, (String) workadress.GetValueAt(0))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.POSTCODE, (String) workadress.GetValueAt(1))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.STREET, (String) workadress.GetValueAt(2))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.COUNTRY, (String) workadress.GetValueAt(3))
		.withValue(ContactsContract.CommonDataKinds.StructuredPostal.TYPE, ContactsContract.CommonDataKinds.StructuredPostal.TYPE_WORK)
		.build());
		
		// Website
		ops.add(ContentProviderOperation.newInsert(ContactsContract.Data.CONTENT_URI)
		.withValueBackReference(ContactsContract.Data.RAW_CONTACT_ID, 0)
		.withValue(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Website.CONTENT_ITEM_TYPE)
		.withValue(ContactsContract.CommonDataKinds.Website.DATA, Website)
		.build());
		
		// Ask the Contact provider to create a new contact
		try {
			ContentResolver cr = m_ba.context.getContentResolver();
			ContentProviderResult[] rc = null;
			rc = cr.applyBatch(ContactsContract.AUTHORITY, ops);
			Log.i(TAG, rc.toString());
		} catch (Exception e) {
			// Log exception
			Log.e(TAG, "Exception encoutered while inserting contact: " + e);
		}	
	}
    
	/**
	* Erzeut eine Map mit allen vorhandenen Kontakten
	* Key ist eine ID, mit der weitere Kontaktinfos abgefragt werden knnen 
	*/
	public Map GetContactMap() {
		Map personen = new Map();
		personen.Initialize();
	
		Uri person = ContactsContract.Contacts.CONTENT_URI;
		String[] person_projection = new String[] {
				ContactsContract.Contacts._ID,
				ContactsContract.Contacts.DISPLAY_NAME
		};
		Cursor person_cur = m_ba.activity.managedQuery(person, person_projection, null, null, null);

		person_cur.moveToFirst();
		while (person_cur.isAfterLast() == false) {
			personen.Put(person_cur.getString(0), person_cur.getString(1));
			person_cur.moveToNext();
		}
		person_cur.close();
		return personen;
	}
	
	/**
	* get contact entry
	*/
	public Map GetContactByID(String id) {

		Map spalten = new Map();
		spalten.Initialize();
		
		// Adressen
		Uri adressen = ContactsContract.CommonDataKinds.StructuredPostal.CONTENT_URI;
		String[] projection = new String[] {
				ContactsContract.CommonDataKinds.StructuredPostal.POSTCODE,
				ContactsContract.CommonDataKinds.StructuredPostal.CITY,
				ContactsContract.CommonDataKinds.StructuredPostal.STREET,
				ContactsContract.CommonDataKinds.StructuredPostal.COUNTRY,
				ContactsContract.CommonDataKinds.StructuredPostal.TYPE
		};
		String selection = ContactsContract.CommonDataKinds.StructuredPostal.CONTACT_ID + " = '" + id + "'";
    
		//query for this specific record:
		Cursor cur = m_ba.activity.managedQuery(adressen, projection, selection, null, null);	

	    int j=0;
		cur.moveToFirst();
		while (cur.isAfterLast() == false) {
			for (int i=0; i<cur.getColumnCount(); i++)
			{
				spalten.Put("Postal" + (j*1000) + i, cur.getString(i));
			}
			j=j+1;
			cur.moveToNext();
		}
		cur.close();	
		
		// EMails
		Uri emails = ContactsContract.CommonDataKinds.Email.CONTENT_URI;
		projection = new String[] {
				ContactsContract.CommonDataKinds.Email.DATA,
				ContactsContract.CommonDataKinds.Email.TYPE
		};
		selection = ContactsContract.CommonDataKinds.Email.CONTACT_ID + " = '" + id + "'";
		Cursor emailcur = m_ba.activity.managedQuery(emails, projection, selection, null, null);	

	    j=0;
	    emailcur.moveToFirst();
		while (emailcur.isAfterLast() == false) {
			for (int i=0; i<emailcur.getColumnCount(); i++)
			{
				spalten.Put("EMail" + (j*1000) + i, emailcur.getString(i));
			}
			j=j+1;
			emailcur.moveToNext();
		}
		emailcur.close();	

		// telefone und Fax
		Uri Phones = ContactsContract.CommonDataKinds.Phone.CONTENT_URI;
		projection = new String[] {
				ContactsContract.CommonDataKinds.Phone.DATA,
				ContactsContract.CommonDataKinds.Phone.TYPE
		};
		selection = ContactsContract.CommonDataKinds.Phone.CONTACT_ID + " = '" + id + "'";
		Cursor Phonecur = m_ba.activity.managedQuery(Phones, projection, selection, null, null);	

	    j=0;
	    Phonecur.moveToFirst();
		while (Phonecur.isAfterLast() == false) {
			for (int i=0; i<Phonecur.getColumnCount(); i++)
			{
				spalten.Put("Phone" + (j*1000) + i, Phonecur.getString(i));
			}
			j=j+1;
			Phonecur.moveToNext();
		}
		Phonecur.close();	

		// Firma, Position
		String orgWhere = ContactsContract.Data.CONTACT_ID + " = ? AND " + ContactsContract.Data.MIMETYPE + " = ?";
		projection = new String[] {
				ContactsContract.CommonDataKinds.Organization.DATA,
				ContactsContract.CommonDataKinds.Organization.TITLE
		};
	 	String[] orgWhereParams = new String[]{id, 
	 		ContactsContract.CommonDataKinds.Organization.CONTENT_ITEM_TYPE}; 
	 	Cursor orgCur = m_ba.activity.managedQuery(ContactsContract.Data.CONTENT_URI, 
	 			projection, orgWhere, orgWhereParams, null);
	 	
	 	j=0;
	 	if (orgCur.moveToFirst()) { 
			for (int i=0; i<orgCur.getColumnCount(); i++)
			{
				spalten.Put("Organization" + (j*1000) + i, orgCur.getString(i));
			}
			j=j+1;
			orgCur.moveToNext();
	 	} 
	 	orgCur.close();		
		
	 	// Kommentare
	 	String noteWhere = ContactsContract.Data.CONTACT_ID + " = ? AND " + ContactsContract.Data.MIMETYPE + " = ?"; 
        String[] noteWhereParams = new String[]{id, 
 		ContactsContract.CommonDataKinds.Note.CONTENT_ITEM_TYPE}; 
		projection = new String[] {
				ContactsContract.CommonDataKinds.Note.NOTE
		};
        Cursor noteCur = m_ba.activity.managedQuery(ContactsContract.Data.CONTENT_URI, projection, noteWhere, noteWhereParams, null); 
    	j=0;
        if (noteCur.moveToFirst()) { 
  			for (int i=0; i<noteCur.getColumnCount(); i++)
        	{
        		spalten.Put("Notes" + (j*1000) + i, noteCur.getString(i));
        	}
        	j=j+1;
        	noteCur.moveToNext();
       	} 
        noteCur.close();		

	 	// Webseite
	 	String webWhere = ContactsContract.Data.CONTACT_ID + " = ? AND " + ContactsContract.Data.MIMETYPE + " = ?"; 
        String[] webWhereParams = new String[]{id, 
 		ContactsContract.CommonDataKinds.Website.CONTENT_ITEM_TYPE}; 
		projection = new String[] {
				ContactsContract.CommonDataKinds.Website.DATA
		};
        Cursor webCur = m_ba.activity.managedQuery(ContactsContract.Data.CONTENT_URI, projection, webWhere, webWhereParams, null); 
    	j=0;
        if (webCur.moveToFirst()) { 
  			for (int i=0; i<webCur.getColumnCount(); i++)
        	{
        		spalten.Put("Web" + (j*1000) + i, webCur.getString(i));
        	}
        	j=j+1;
        	webCur.moveToNext();
       	} 
        webCur.close();		
        
		return spalten;
	}

	public Bitmap GetContactPhotoByID(String id) {

		// Photo
		Uri photo = ContactsContract.Data.CONTENT_URI;
		String[] projection = new String[] {
				ContactsContract.CommonDataKinds.Photo.PHOTO
		};
		String selection = ContactsContract.CommonDataKinds.StructuredPostal.CONTACT_ID + " = '" + id + "'";
    
		//query for this specific record:
		Cursor cur = m_ba.activity.managedQuery(photo, projection, selection, null, null);	

	    int j=0;
		cur.moveToFirst();
		while (cur.isAfterLast() == false) {
			for (int i=0; i<cur.getColumnCount(); i++)
			{
				byte[] photodata = cur.getBlob(i);
				if (photodata != null) {
					Log.i(TAG, "Empfange Photo: " + photodata.length);
				    Bitmap bmp = BitmapFactory.decodeByteArray(photodata, 0, photodata.length);
					cur.close();	
					return(bmp);	
				}
			}
			j=j+1;
			cur.moveToNext();
		}
		cur.close();	
		return(null);	
	}
}
